Index: moodle/blocks/settings_navigation_tree/block_settings_navigation_tree.php
--- moodle/blocks/settings_navigation_tree/block_settings_navigation_tree.php No Base Revision
+++ moodle/blocks/settings_navigation_tree/block_settings_navigation_tree.php Locally New
@@ -0,0 +1,149 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * This file contains classes used to manage the navigation structures in Moodle
+ * and was introduced as part of the changes occuring in Moodle 2.0
+ *
+ * @since 2.0
+ * @package blocks
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/**
+ * The settings navigation tree block class
+ *
+ * Used to produce the settings navigation block new to Moodle 2.0
+ *
+ * @package blocks
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class block_settings_navigation_tree extends block_tree {
+
+    /** @var string */
+    public static $navcount;
+    public $blockname = null;
+    protected $contentgenerated = false;
+    public $id = null;
+
+    /**
+     * Set the initial properties for the block
+     */
+    function init() {
+        $this->blockname = get_class($this);
+        $this->title = get_string('blockname', $this->blockname);
+        $this->version = 2009082800;
+    }
+
+    /**
+     * All multiple instances of this block
+     * @return bool Returns true
+     */
+    function instance_allow_multiple() {
+        return false;
+    }
+
+    /**
+     * Set the applicable formats for this block to all
+     * @return array
+     */
+    function applicable_formats() {
+        return array('all' => true);
+    }
+
+    /**
+     * Allow the user to configure a block instance
+     * @return bool Returns true
+     */
+    function instance_allow_config() {
+        return true;
+    }
+
+    /**
+     * Gets the content for this block by grabbing it from $this->page
+     */
+    function get_content() {
+        global $CFG, $OUTPUT;
+        // First check if we have already generated, don't waste cycles
+        if ($this->contentgenerated === true) {
+            return true;
+        }
+        $this->page->requires->js('lib/javascript-navigation.js');
+        block_settings_navigation_tree::$navcount++;
+
+        $tooglesidetabdisplay = get_string('tooglesidetabdisplay', $this->blockname);
+        $toogleblockdisplay = get_string('toogleblockdisplay', $this->blockname);
+        $args = array('instance'=>$this->instance->id);
+        $args['tooglesidetabdisplay'] = $tooglesidetabdisplay;
+        $args['toogleblockdisplay'] = $toogleblockdisplay;
+        // Give JS some information we will use within the JS tree object
+        $this->page->requires->data_for_js('settingsnav'.block_settings_navigation_tree::$navcount, $args);
+
+
+        $this->id = 'settingsnav'.block_settings_navigation_tree::$navcount;
+        $this->page->requires->js_function_call('setup_new_navtree', array($this->id))->on_dom_ready();
+        // Grab the children from settings nav, we have more than one root node
+        // and we dont want to show the site node
+        $this->content->items = $this->page->settingsnav->children;
+        // only do search if you have moodle/site:config
+        if (count($this->content->items)>0) {
+            if (has_capability('moodle/site:config',get_context_instance(CONTEXT_SYSTEM)) ) {
+                $this->content->footer =
+                        '<div class="adminsearchform">'.
+                        '<form action="'.$CFG->wwwroot.'/'.$CFG->admin.'/search.php" method="get"><div>'.
+                        '<label for="query" class="accesshide">'.get_string('searchinsettings', 'admin').'</label>'.
+                        '<input type="text" name="query" id="query" size="8" value="'.s(optional_param('query', '')).'" />'.
+                        '<input type="submit" value="'.get_string('search').'" /></div>'.
+                        '</form></div>';
+            } else {
+                $this->content->footer = '';
+            }
+
+            $url = $this->page->url;
+            $url->param('regenerate','navigation');
+            $reloadstr = get_string('reload');
+            $this->content->footer .= '<a href="'.$url->out().'" class="customcommand"><img src="'.$OUTPUT->old_icon_url('t/reload').'" alt="'.$reloadstr.'" title="'.$reloadstr.'" /></a>';
+            if (!empty($this->config->enablesidebarpopout) && $this->config->enablesidebarpopout == 'yes') {
+                user_preference_allow_ajax_update('nav_in_tab_panel_settingsnav'.block_settings_navigation_tree::$navcount, PARAM_INT);
+                if (get_user_preferences('nav_in_tab_panel_settingsnav'.block_settings_navigation_tree::$navcount, 0)) {
+                    $icon = $OUTPUT->old_icon_url('t/movetoblock');
+                    $string = $toogleblockdisplay;
+                } else {
+                    $icon = $OUTPUT->old_icon_url('t/movetosidetab');
+                    $string = $tooglesidetabdisplay;
+                }
+                $this->content->footer .= '<a class="moveto customcommand requiresjs"><img src="'.$icon.'" alt="'.$string.'" title="'.$string.'"></a>';
+            }
+        }
+
+        $this->contentgenerated = true;
+        return true;
+    }
+
+    function html_attributes() {
+        $attributes = parent::html_attributes();
+        if (!empty($this->config->enablehoverexpansion) && $this->config->enablehoverexpansion == 'yes') {
+            $attributes['class'] .= ' sideblock_js_expansion';
+        }
+        if (get_user_preferences('nav_in_tab_panel_settingsnav'.block_settings_navigation_tree::$navcount, 0)) {
+            $attributes['class'] .= ' sideblock_js_sidebarpopout';
+        }
+        return $attributes;
+    }
+}
Index: moodle/blocks/settings_navigation_tree/edit_form.php
--- moodle/blocks/settings_navigation_tree/edit_form.php No Base Revision
+++ moodle/blocks/settings_navigation_tree/edit_form.php Locally New
@@ -0,0 +1,54 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Form for editing settings navigation instances.
+ *
+ * @since 2.0
+ * @package blocks
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/**
+ * Form for setting navigation instances.
+ *
+ * @package blocks
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class block_settings_navigation_tree_edit_form extends block_edit_form {
+    protected function specific_definition($mform) {
+        $mform->addElement('header', 'configheader', get_string('blocksettings', 'block'));
+
+        $yesnooptions = array('yes'=>get_string('yes'), 'no'=>get_string('no'));
+
+        $mform->addElement('select', 'config_enablehoverexpansion', get_string('enablehoverexpansion', $this->block->blockname), $yesnooptions);
+        if (empty($this->block->config->enablehoverexpansion) || $this->block->config->enablehoverexpansion=='no') {
+            $mform->getElement('config_enablehoverexpansion')->setSelected('no');
+        } else {
+            $mform->getElement('config_enablehoverexpansion')->setSelected('yes');
+        }
+
+        $mform->addElement('select', 'config_enablesidebarpopout', get_string('enablesidebarpopout', $this->block->blockname), $yesnooptions);
+        if (empty($this->block->config->enablesidebarpopout) || $this->block->config->enablesidebarpopout=='no') {
+            $mform->getElement('config_enablesidebarpopout')->setSelected('no');
+        } else {
+            $mform->getElement('config_enablesidebarpopout')->setSelected('yes');
+        }
+    }
+}
Index: moodle/course/category.php
--- moodle/course/category.php Base (1.162)
+++ moodle/course/category.php Locally Modified (Based On 1.162)
@@ -142,11 +142,6 @@
     $strcategory = get_string('category');
     $strcourses = get_string('courses');
 
-    $navlinks = array();
-    $navlinks[] = array('name' => $strcategories, 'link' => 'index.php', 'type' => 'misc');
-    $navlinks[] = array('name' => format_string($category->name), 'link' => null, 'type' => 'misc');
-    $navigation = build_navigation($navlinks);
-
     if ($editingon && can_edit_in_category()) {
         // Integrate into the admin tree only if the user can edit categories at the top level,
         // otherwise the admin block does not appear to this user, and you get an error.
@@ -156,7 +151,7 @@
         admin_externalpage_print_header();
     } else {
         $navbaritem = print_course_search('', true, 'navbar');
-        print_header("$site->shortname: $category->name", "$site->fullname: $strcourses", $navigation, '', '', true, $navbaritem);
+        print_header("$site->shortname: $category->name", "$site->fullname: $strcourses", array(), '', '', true, $navbaritem);
     }
 
 /// Print link to roles
Index: moodle/course/format/scorm/config.php
--- moodle/course/format/scorm/config.php Base (1.1)
+++ moodle/course/format/scorm/config.php Locally Modified (Based On 1.1)
@@ -6,7 +6,6 @@
 // social format.
 //
 // The default blocks layout for this course format:
-    $format['defaultblocks'] = 'participants,social_activities,admin,course_list:'.
-                               'news_items,recent_activity,calendar_upcoming';
+    $format['defaultblocks'] = ':news_items,recent_activity,calendar_upcoming';
 
 ?>
Index: moodle/course/format/scorm/lib.php
--- moodle/course/format/scorm/lib.php No Base Revision
+++ moodle/course/format/scorm/lib.php Locally New
@@ -0,0 +1,55 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * This file contains general functions for the course format SCORM
+ *
+ * @since 2.0
+ * @package moodlecore
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/**
+ * The string that is used to describe a section of the course
+ * e.g. Topic, Week...
+ *
+ * @return string
+ */
+function callback_scorm_definition() {
+    return get_string('scorm');
+}
+
+/**
+ * The GET argument variable that is used to identify the section being
+ * viewed by the user (if there is one)
+ *
+ * @return string
+ */
+function callback_scorm_request_keyscorm() {
+    return 'scorm';
+}
+
+/**
+ * Toogle display of course contents (sections, activities)
+ *
+ * @return bool
+ */
+function callback_scorm_display_content() {
+    return false;
+}
+
+?>
Index: moodle/course/format/social/config.php
--- moodle/course/format/social/config.php Base (1.2)
+++ moodle/course/format/social/config.php Locally Modified (Based On 1.2)
@@ -6,7 +6,6 @@
 // social format.
 //
 // The default blocks layout for this course format:
-    $format['defaultblocks'] = 'participants,search_forums,calendar_upcoming,'.
-                               'social_activities,recent_activity,admin,course_list';
+    $format['defaultblocks'] = ':search_forums,calendar_upcoming,social_activities,recent_activity,admin,course_list';
 
 ?>
Index: moodle/course/format/social/lib.php
--- moodle/course/format/social/lib.php No Base Revision
+++ moodle/course/format/social/lib.php Locally New
@@ -0,0 +1,83 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * This file contains general functions for the course format Social
+ *
+ * @since 2.0
+ * @package moodlecore
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/**
+ * Used to display the course structure for a course where format=social
+ *
+ * This is called automatically by {@link load_course()} if the current course
+ * format = weeks.
+ *
+ * @param array $path An array of keys to the course node in the navigation
+ * @param stdClass $modinfo The mod info object for the current course
+ * @return bool Returns true
+ */
+function load_course_format_social(&$navigation, $keys, $course) {
+    $navigation->add_course_section_generic($keys, $course, get_string('social'), 'social');
+}
+
+/**
+ * Used to display the course structure for a course where format=social
+ *
+ * This is called automatically by {@link load_course()} if the current course
+ * format = weeks and the navigation was requested via AJAX
+ *
+ * @param array $path An array of keys to the course node in the navigation
+ * @param stdClass $modinfo The mod info object for the current course
+ * @return bool Returns true
+ */
+function limited_load_section_social(&$navigation, $keys, $course, $section) {
+    $navigation->limited_load_section_generic($keys, $course, $section, get_string('social'), 'social');
+}
+
+/**
+ * The string that is used to describe a section of the course
+ * e.g. Topic, Week...
+ *
+ * @return string
+ */
+function callback_social_definition() {
+    return get_string('social');
+}
+
+/**
+ * The GET argument variable that is used to identify the section being
+ * viewed by the user (if there is one)
+ *
+ * @return string
+ */
+function callback_social_request_key() {
+    return 'social';
+}
+
+/**
+ * Toogle display of course contents (sections, activities)
+ *
+ * @return bool
+ */
+function callback_social_display_content() {
+    return false;
+}
+
+?>
Index: moodle/course/format/topics/config.php
--- moodle/course/format/topics/config.php Base (1.2)
+++ moodle/course/format/topics/config.php Locally Modified (Based On 1.2)
@@ -6,8 +6,6 @@
 // format.
 //
 // The default blocks layout for this course format:
-    $format['defaultblocks'] = 'participants,activity_modules,search_forums,'.
-                               'admin,course_list:news_items,calendar_upcoming,'.
-                               'recent_activity';
+    $format['defaultblocks'] = ':search_forums,news_items,calendar_upcoming,recent_activity';
 //
 ?>
Index: moodle/course/format/topics/lib.php
--- moodle/course/format/topics/lib.php No Base Revision
+++ moodle/course/format/topics/lib.php Locally New
@@ -0,0 +1,73 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * This file contains general functions for the course format Topic
+ *
+ * @since 2.0
+ * @package moodlecore
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/**
+ * Used to display the course structure for a course where format=topic
+ *
+ * This is called automatically by {@link load_course()} if the current course
+ * format = weeks.
+ *
+ * @param array $path An array of keys to the course node in the navigation
+ * @param stdClass $modinfo The mod info object for the current course
+ * @return bool Returns true
+ */
+function callback_topics_load_content(&$navigation, $keys, $course) {
+    $navigation->add_course_section_generic($keys, $course, get_string('topic'), 'topic');
+}
+
+/**
+ * Used to display the course structure for a course where format=topic
+ *
+ * This is called automatically by {@link load_course()} if the current course
+ * format = weeks and the navigation was requested via AJAX
+ *
+ * @param array $path An array of keys to the course node in the navigation
+ * @param stdClass $modinfo The mod info object for the current course
+ * @return bool Returns true
+ */
+function callback_topics_load_limited_section(&$navigation, $keys, $course, $section) {
+    $navigation->limited_load_section_generic($keys, $course, $section, get_string('topic'), 'topic');
+}
+
+/**
+ * The string that is used to describe a section of the course
+ * e.g. Topic, Week...
+ *
+ * @return string
+ */
+function callback_topics_definition() {
+    return get_string('topic');
+}
+
+/**
+ * The GET argument variable that is used to identify the section being
+ * viewed by the user (if there is one)
+ *
+ * @return string
+ */
+function callback_topics_request_key() {
+    return 'topic';
+}
+?>
Index: moodle/course/format/weeks/config.php
--- moodle/course/format/weeks/config.php Base (1.2)
+++ moodle/course/format/weeks/config.php Locally Modified (Based On 1.2)
@@ -6,8 +6,6 @@
 // format.
 //
 // The default blocks layout for this course format:
-    $format['defaultblocks'] = 'participants,activity_modules,search_forums,'.
-                               'admin,course_list:news_items,calendar_upcoming,'.
-                               'recent_activity';
+    $format['defaultblocks'] = ':search_forums,news_items,calendar_upcoming,recent_activity';
 //
 ?>
Index: moodle/course/format/weeks/lib.php
--- moodle/course/format/weeks/lib.php No Base Revision
+++ moodle/course/format/weeks/lib.php Locally New
@@ -0,0 +1,73 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * This file contains general functions for the course format Week
+ *
+ * @since 2.0
+ * @package moodlecore
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/**
+ * Used to display the course structure for a course where format=weeks
+ *
+ * This is called automatically by {@link load_course()} if the current course
+ * format = weeks.
+ *
+ * @param array $path An array of keys to the course node in the navigation
+ * @param stdClass $modinfo The mod info object for the current course
+ * @return bool Returns true
+ */
+function callback_weeks_load_content(&$navigation, $keys, $course) {
+    $navigation->add_course_section_generic($keys, $course, get_string('week'), 'week');
+}
+
+/**
+ * Used to display the course structure for a course where format=weeks
+ *
+ * This is called automatically by {@link load_course()} if the current course
+ * format = weeks and the navigation was requested via AJAX
+ *
+ * @param array $path An array of keys to the course node in the navigation
+ * @param stdClass $modinfo The mod info object for the current course
+ * @return bool Returns true
+ */
+function callback_weeks_load_limited_section(&$navigation, $keys, $course, $section) {
+    $navigation->limited_load_section_generic($keys, $course, $section, get_string('week'), 'week');
+}
+
+/**
+ * The string that is used to describe a section of the course
+ * e.g. Topic, Week...
+ *
+ * @return string
+ */
+function callback_weeks_definition() {
+    return get_string('week');
+}
+
+/**
+ * The GET argument variable that is used to identify the section being
+ * viewed by the user (if there is one)
+ *
+ * @return string
+ */
+function callback_weeks_request_key() {
+    return 'week';
+}
+?>
Index: moodle/course/search.php
--- moodle/course/search.php Base (1.81)
+++ moodle/course/search.php Locally Modified (Based On 1.81)
@@ -204,7 +204,9 @@
     $navlinks = array();
     $navlinks[] = array('name' => $strcourses, 'link' => 'index.php', 'type' => 'misc');
     $navlinks[] = array('name' => $strsearch, 'link' => 'search.php', 'type' => 'misc');
+    if (!empty($search)) {
     $navlinks[] = array('name' => "'".s($search)."'", 'link' => null, 'type' => 'misc');
+    }
     $navigation = build_navigation($navlinks);
 
     print_header("$site->fullname : $strsearchresults", $site->fullname, $navigation, "", "", "", $searchform);
Index: moodle/course/switchrole.php
--- moodle/course/switchrole.php No Base Revision
+++ moodle/course/switchrole.php Locally New
@@ -0,0 +1,84 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * The purpose of this file is to allow the user to switch roles and be redirected
+ * back to the page that they were on.
+ *
+ * This functionality is also supported in {@link /course/view.php} in order to comply
+ * with backwards compatibility
+ * The reason that we created this file was so that user didn't get redirected back
+ * to the course view page only to be redirected again.
+ *
+ * @since 2.0
+ * @package moodlecore
+ * @subpackage navigation
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+require_once('../config.php');
+require_once($CFG->dirroot.'/course/lib.php');
+
+$id          = required_param('id', PARAM_INT);
+$switchrole  = optional_param('switchrole',-1, PARAM_INT);
+$returnurlkey = optional_param('returnurl', false, PARAM_INT);
+
+if (!confirm_sesskey()) {
+    print_error('confirmsesskeybad', 'error');
+}
+
+if (! ($course = $DB->get_record('course', array('id'=>$id)))) {
+    print_error('invalidcourseid', 'error');
+}
+
+if (!$context = get_context_instance(CONTEXT_COURSE, $course->id)) {
+    print_error('nocontext');
+}
+
+// Remove any switched roles before checking login
+if ($switchrole == 0) {
+    role_switch($switchrole, $context);
+}
+require_login($course);
+
+// Switchrole - sanity check in cost-order...
+if ($switchrole > 0 && has_capability('moodle/role:switchroles', $context)) {
+    // is this role assignable in this context?
+    // inquiring minds want to know...
+    $aroles = get_switchable_roles($context);
+    if (is_array($aroles) && isset($aroles[$switchrole])) {
+        role_switch($switchrole, $context);
+        // Double check that this role is allowed here
+        require_login($course);
+    }
+}
+
+$returnurl = false;
+if ($returnurlkey && !empty($SESSION->returnurl) && strpos($SESSION->returnurl, 'moodle_url')!==false) {
+    $returnurl = @unserialize($SESSION->returnurl);
+    if (!($returnurl instanceof moodle_url)) {
+        $returnurl = false;
+    }
+    unset($SESSION->returnurl);
+}
+
+if ($returnurl===false) {
+    $returnurl = new moodle_url('/course/view.php', array('id'=>$course->id));
+}
+redirect($returnurl);
+
+?>
Index: moodle/index.php
--- moodle/index.php Base (1.243)
+++ moodle/index.php Locally Modified (Based On 1.243)
@@ -87,7 +87,7 @@
     $editing = $PAGE->user_is_editing();
     $PAGE->set_title($SITE->fullname);
     $PAGE->set_heading($SITE->fullname);
-    echo $OUTPUT->header('', user_login_string($SITE) . $langmenu);
+    echo $OUTPUT->header(user_login_string($SITE) . $langmenu);
 
 /// Print Section
     if ($SITE->numsections > 0) {
Index: moodle/install.php
--- moodle/install.php Base (1.134)
+++ moodle/install.php Locally Modified (Based On 1.134)
@@ -47,7 +47,7 @@
 @error_reporting(E_ALL);
 @ini_set('display_errors', '1');
 // we need a lot of memory
-@ini_set('memory_limit', '40M');
+@ini_set('memory_limit', '60M');
 
 // Check that PHP is of a sufficient version
 if (version_compare(phpversion(), "5.2.0") < 0) {
Index: moodle/lang/en_utf8/block_global_navigation_tree.php
--- moodle/lang/en_utf8/block_global_navigation_tree.php No Base Revision
+++ moodle/lang/en_utf8/block_global_navigation_tree.php Locally New
@@ -0,0 +1,40 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * This file contains language strings used in the global navigation block
+ *
+ * @since 2.0
+ * @package blocks
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+$string['blockname'] = 'Navigation';
+$string['expansionlimit'] = 'Generate navigation for the following';
+$string['everything'] = 'Everything';
+$string['courses'] = 'Categories and courses';
+$string['coursestructures'] = 'Categories, courses, and course structures';
+$string['courseactivities'] = 'Categories, courses, and course Activities';
+$string['showemptybranchesdesc'] = 'Show empty course section branches';
+$string['showmycoursesdesc'] = 'Show my courses in the navigation';
+$string['enablehoverexpansiondesc'] = 'Enable mouseover expansion of this block';
+$string['enablesidebarpopoutdesc'] = 'Allow the user to switch the block to a sidbar popout';
+$string['showmyhistorydesc'] = 'Show my history as a branch in the navigation';
+$string['showmyhistorytitle'] = 'My history';
+$string['toogleblockdisplay'] = 'Move to block position';
+$string['tooglesidetabdisplay'] = 'Move to side panel tab';
Index: moodle/lang/en_utf8/block_settings_navigation_tree.php
--- moodle/lang/en_utf8/block_settings_navigation_tree.php No Base Revision
+++ moodle/lang/en_utf8/block_settings_navigation_tree.php Locally New
@@ -0,0 +1,31 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * This file contains language strings used in the settings navigation block
+ *
+ * @since 2.0
+ * @package blocks
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+$string['blockname'] = 'Settings';
+$string['enablehoverexpansion'] = 'Enable mouseover expansion of this block';
+$string['enablesidebarpopout'] = 'Allow the user to switch the block to a sidbar popout';
+$string['toogleblockdisplay'] = 'Move to block position';
+$string['tooglesidetabdisplay'] = 'Move to side panel tab';
Index: moodle/lang/en_utf8/forum.php
--- moodle/lang/en_utf8/forum.php Base (1.60)
+++ moodle/lang/en_utf8/forum.php Locally Modified (Based On 1.60)
@@ -126,6 +126,7 @@
 $string['forcesubscribe'] = 'Force everyone to be subscribed';
 $string['forcesubscribeq'] = 'Force everyone to be subscribed?';
 $string['forum'] = 'Forum';
+$string['forumadministration'] = 'Forum Administration';
 $string['forum:addnews'] = 'Add news';
 $string['forumauthorhidden'] = 'Author (hidden)';
 $string['forumblockingalmosttoomanyposts'] = 'You are approaching the posting threshold. You have posted $a->numposts times in the last $a->blockperiod and the limit is $a->blockafter posts.';
@@ -350,6 +351,7 @@
 $string['unsubscribed'] = 'Unsubscribed';
 $string['unsubscribeshort'] = 'Unsubscribe';
 $string['usermarksread'] = 'Manual message read marking';
+$string['viewalldiscussions'] = 'View all discussions';
 $string['warnafter'] = 'Post threshold for warning';
 $string['yesforever'] = 'Yes, forever';
 $string['yesinitially'] = 'Yes, initially';
